package org.zen.xhtml.editor;

 
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Display;

/**
 * @author Zenil
 * @version 1.0
 */
public class ColorManager {
	
	private static ColorManager fColorManager = new ColorManager();
	
	private ColorManager(){
	}
	
	protected Map fColorTable = new HashMap(10);

	public void dispose() {
		Iterator e= fColorTable.values().iterator();
		while (e.hasNext())
			((Color) e.next()).dispose();
	}
	public Color getColor(RGB rgb) {
		Color color= (Color) fColorTable.get(rgb);
		if (color == null) {
			color= new Color(Display.getCurrent(), rgb);
			fColorTable.put(rgb, color);
		}
		return color;
	}
	
	public static ColorManager getColorManager() {
		return fColorManager;
	}
}
