package org.zen.xhtml.editor.parser;

import java.io.IOException;
import java.io.StringReader;

import org.apache.xerces.parsers.DOMParser;
import org.eclipse.jface.text.IDocument;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * @author Zenil
 * @version 1.0
 */
public class DOMXHTMLParser {
	/** Vendor DOMImplementation impl class */
	private static String vendorImplementationClass = "org.apache.xerces.parsers.DOMParser";//$NON-NLS-1$
	private static DOMParser fParser ;
	private static Document fParsedDoc;
	
	public static Document parse(IDocument doc) {
		StringReader strReader = new StringReader(doc.get());
		try {
			if(fParser==null)	{
				fParser=(DOMParser) Class.forName(vendorImplementationClass).newInstance();
			}
			InputSource inputSource = new InputSource(strReader);
			fParser.parse(inputSource);			
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			System.out.println("XHTML Error Message = "+e.getMessage()+"\n Cause = "+e.getCause().getMessage());
		} catch (IOException e) {
			e.printStackTrace();
		}
		Document parsedDoc = fParser.getDocument();
		fParsedDoc = parsedDoc;
		
		return fParsedDoc;
	}
	
	
		
}
