package org.zen.xhtml.editor.parser;

import java.io.IOException;
import java.io.StringReader;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.DTD;
import javax.swing.text.html.parser.DocumentParser;

import org.eclipse.jface.text.IDocument;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * @author Zenil
 * @version 1.0
 */
public class SAXHTMLParser {

	/** Default parser to use */
	private static String vendorParserClass = "org.apache.xerces.parsers.SAXParser";

	public static void parse(IDocument doc) {
			
		StringReader strReader = new StringReader(doc.get());
		try {
			try {
				//This is not working..ClassNotFoundException being thrown
				//XMLReader reader = XMLReaderFactory.createXMLReader(vendorParserClass);
				Class parserClass = Class.forName(vendorParserClass);
				XMLReader reader = (XMLReader)parserClass.newInstance();
				
				reader.setContentHandler(new SAXHTMLContentHandler());
				
				// Request validation
				reader.setFeature("http://xml.org/sax/features/validation", true);
				reader.setFeature("http://apache.org/xml/features/validation/schema",true);
				reader.setFeature("http://xml.org/sax/features/namespaces", true);
				reader.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
				
				InputSource inputSource = new InputSource(strReader);
				reader.parse(inputSource);
			} catch (SAXNotRecognizedException e) {
				e.printStackTrace();
			} catch (SAXNotSupportedException e) {
				e.printStackTrace();
			} catch (SAXException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
		} catch (IllegalAccessException e) {
		}
		
	}
}
