package org.zen.xhtml.editor.parser;

import javax.swing.text.html.HTML;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.w3c.dom.Node;
import org.zen.xhtml.editor.util.PluginImages;

/**
 * @author Zenil
 * @version 1.0
 */
public class XHTMLLabelProvider extends LabelProvider {

	/**
	 * @see org.eclipse.jface.viewers.ILabelProvider#getImage(Object)
	 */
	public Image getImage(Object element) {
		Image image = null;
		if(element instanceof Node) {
			Node node = (Node)element;
			int type = node.getNodeType();
			if(type==Node.ELEMENT_NODE) {
				if(HTML.getTag(node.getNodeName())!=null) {
					image = PluginImages.get(PluginImages.IMG_PRE_DEFINED_TAG);
				} else {
					image = PluginImages.get(PluginImages.IMG_USER_DEFINED_TAG);
				}
			} else if(type==Node.ATTRIBUTE_NODE)  {
				image = PluginImages.get(PluginImages.IMG_ATTR);
			} else {
				image = PluginImages.get(PluginImages.IMG_OTHER);
			}
		}
		return image;
	}

	/**
	 * @see org.eclipse.jface.viewers.ILabelProvider#getText(Object)
	 */
	public String getText(Object element) {
		String text = "";//$NON-NLS-1$
		if(element instanceof Node) {
			Node node = (Node)element;
			text = node.toString();
			//for every node other than attribute name get the node name
			//for attribute node the toString() returns proper value
			if(node.getNodeType()!=node.ATTRIBUTE_NODE) {
				if(node.getNodeType()!=Node.TEXT_NODE) {
					text = node.getNodeName();
				}
			}
		}
		
		return text;
	}

}
