package org.zen.xhtml.editor.preferencePage;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.zen.xhtml.editor.XHTMLEditorPlugin;

/**
 * @author Zenil
 * @version 1.0 
 * @see PreferencePage
 */
public class XHTMLPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
	/**
	 * The constructor.
	 */
	public XHTMLPreferencePage() {
		super(FieldEditorPreferencePage.GRID);

		// Set the preference store for the preference page.
		IPreferenceStore store = XHTMLEditorPlugin.getDefault().getPreferenceStore();
		setPreferenceStore(store);

	}

	protected void createFieldEditors() {
		
		SpacerFieldEditor spacer1 = new SpacerFieldEditor(getFieldEditorParent());
		addField(spacer1);

		// Initialize all field editors.
		BooleanFieldEditor showVRuler =
			new BooleanFieldEditor(IPreferenceConstants.VRULER_PREFERENCE, "Show &vertical ruler", getFieldEditorParent());
		addField(showVRuler);

		spacer1 = new SpacerFieldEditor(getFieldEditorParent());
		addField(spacer1);

		BooleanFieldEditor showHRuler =
			new BooleanFieldEditor(IPreferenceConstants.HRULER_PREFERENCE, "Show &horizontal ruler", getFieldEditorParent());
		addField(showHRuler);
	}
	
	/**
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}
	
	/**
	 * @see org.eclipse.jface.preference.IPreferencePage#performOk()
	 */
	public boolean performOk() {
		
		boolean isOk = super.performOk();
		//Save the preferences as soon as OK is pressed,not at workspace shutdown
		if(isOk)
			XHTMLEditorPlugin.getDefault().savePluginPreferences();
	
		return isOk;
	}


}
